import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.imageio.*;
import java.util.*;

/**
 * タイトル.
 * <pre>
 * タイトルを表示するオブジェクト。
 * </pre>
 */
public class KTextTitle extends KText{

	/**
	 * フォント.
	 */
	private Font font = new Font("HGS創英角ﾎﾟｯﾌﾟ体", Font.PLAIN, 96);

	/**
	 * 文字列.
	 */
	private String strText0 = "パズルで";
	private String strText1 = "ズルズル";

	/**
	 * X位置.
	 */
	private int intX0 = 40;
	private int intX1 = 120;

	/**
	 * Y位置.
	 */
	private int intY0 = 160;
	private int intY1 = 256;

	/**
	 * 色一覧.
	 */
	private Color[] colors = {	Color.red,
								new Color(255,  64,   0),
								new Color(255, 128,   0),
								new Color(255, 192,   0),
								Color.yellow,
								new Color(192, 255,   0),
								new Color(128, 255,   0),
								new Color( 64, 255,   0),
								Color.green,
								new Color(  0, 255,  64),
								new Color(  0, 255, 128),
								new Color(  0, 255, 192),
								Color.cyan,
								new Color(  0, 192, 255),
								new Color(  0, 128, 255),
								new Color(  0,  64, 255),
								Color.blue,
								new Color( 64,   0, 255),
								new Color(128,   0, 255),
								new Color(192,   0, 255),
								Color.magenta,
								new Color(255,   0, 192),
								new Color(255,   0, 128),
								new Color(255,   0,  64)
	};

	/**
	 * 時間.
	 */
	private int time = 0;

	/**
	 * コンストラクタ.
	 * @param panel パネル
	 * @param intX 表示位置。X座標。
	 * @param intY 表示位置。Y座標。
	 */
	public KTextTitle(KPanel panel, int intX, int intY){

		super(panel, intX, intY, Color.white);

	} // end KText

	/**
	 * スプライト描画.
	 * <pre>
	 * 表示の必要があれば実行される。
	 * </pre>
	 */
	public void paint(Graphics g){

		time++;

		// 上の文字のループ
		for(int i = 0; i < 4; i++){

			// フォント
			g.setFont(font);

			// 色
			g.setColor(this.colors[(time / 5 + (4 - i)) % colors.length]);

			// 文字列を表示
			g.drawString(strText0.substring(i, i + 1), intX0 + i * 96, intY0);

		} // end for 上の文字のループ

		// 下の文字のループ
		for(int i = 0; i < 4; i++){

			// フォント
			g.setFont(font);

			// 色
			g.setColor(this.colors[(time / 5 + (4 - i) + 12) % colors.length]);

			// 文字列を表示
			g.drawString(strText1.substring(i, i + 1), intX1 + i * 96, intY1);

		} // end for 上の文字のループ

	} // end paint

}
